pub fn profile<F, T>(tag: &str, f: F) -> T
where
    F: FnOnce() -> T,
{
    let start_time = std::time::Instant::now();
    let retval = f();
    let end_time = std::time::Instant::now();
    println!("[{}] {:?}", tag, end_time - start_time);
    retval
}

/*
struct Profile {
    metric: Arc<RwLock<HashMap<String, [f64; 100]>>>,
    receiver: async_channel::Receiver<(String, f64)>,
}

impl Profile {
    async fn run(&self) {
        loop {
            if let Ok(name, value) = self.receiver.recv().await {
                self.metric.write().unwrap().entry(name).and_modify(|metric| metric.).or_insert(vec![0.; 100]);
            }
        }
    }
}
*/
